diff -ruNp linux-2.6.23.16/arch/i386/kernel/ioport.c linux-2.6.23.16-cher1/arch/i386/kernel/ioport.c
--- linux-2.6.23.16/arch/i386/kernel/ioport.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/ioport.c	2008-02-12 11:21:39.000000000 +0300
@@ -62,6 +62,11 @@ asmlinkage long sys_ioperm(unsigned long
 	struct tss_struct * tss;
 	unsigned long *bitmap;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if ((from + num <= from) || (from + num > IO_BITMAP_BITS))
 		return -EINVAL;
 	if (turn_on && !capable(CAP_SYS_RAWIO))
@@ -139,6 +144,11 @@ asmlinkage long sys_iopl(unsigned long u
 	unsigned int old = (regs->eflags >> 12) & 3;
 	struct thread_struct *t = &current->thread;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	if (level > 3)
 		return -EINVAL;
 	/* Trying to gain more privileges? */
@@ -151,3 +161,9 @@ asmlinkage long sys_iopl(unsigned long u
 	set_iopl_mask(t->iopl);
 	return 0;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/arch/i386/kernel/ldt.c linux-2.6.23.16-cher1/arch/i386/kernel/ldt.c
--- linux-2.6.23.16/arch/i386/kernel/ldt.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/ldt.c	2008-02-12 11:21:39.000000000 +0300
@@ -232,6 +232,11 @@ asmlinkage int sys_modify_ldt(int func, 
 {
 	int ret = -ENOSYS;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	switch (func) {
 	case 0:
 		ret = read_ldt(ptr, bytecount);
diff -ruNp linux-2.6.23.16/arch/i386/kernel/process.c linux-2.6.23.16-cher1/arch/i386/kernel/process.c
--- linux-2.6.23.16/arch/i386/kernel/process.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/process.c	2008-02-12 11:21:39.000000000 +0300
@@ -782,6 +782,11 @@ asmlinkage int sys_execve(struct pt_regs
 	int error;
 	char * filename;
 
+        if ((current->sbox_flags & SBOX_NO_EXEC)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	filename = getname((char __user *) regs.ebx);
 	error = PTR_ERR(filename);
 	if (IS_ERR(filename))
@@ -793,6 +798,8 @@ asmlinkage int sys_execve(struct pt_regs
 	if (error == 0) {
 		task_lock(current);
 		current->ptrace &= ~PT_DTRACE;
+                if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                        current->sbox_flags |= SBOX_NO_EXEC;
 		task_unlock(current);
 		/* Make sure we don't return using sysenter.. */
 		set_thread_flag(TIF_IRET);
@@ -949,3 +956,9 @@ unsigned long arch_align_stack(unsigned 
 		sp -= get_random_int() % 8192;
 	return sp & ~0xf;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/arch/i386/kernel/signal.c linux-2.6.23.16-cher1/arch/i386/kernel/signal.c
--- linux-2.6.23.16/arch/i386/kernel/signal.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/signal.c	2008-02-12 11:21:39.000000000 +0300
@@ -37,6 +37,9 @@
 asmlinkage int
 sys_sigsuspend(int history0, int history1, old_sigset_t mask)
 {
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	mask &= _BLOCKABLE;
 	spin_lock_irq(&current->sighand->siglock);
 	current->saved_sigmask = current->blocked;
@@ -665,3 +668,9 @@ void do_notify_resume(struct pt_regs *re
 	
 	clear_thread_flag(TIF_IRET);
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/arch/i386/kernel/sys_i386.c linux-2.6.23.16-cher1/arch/i386/kernel/sys_i386.c
--- linux-2.6.23.16/arch/i386/kernel/sys_i386.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/sys_i386.c	2008-02-12 11:21:39.000000000 +0300
@@ -33,6 +33,9 @@ asmlinkage int sys_pipe(unsigned long __
 	int fd[2];
 	int error;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS))
+                return -EPERM;
+
 	error = do_pipe(fd);
 	if (!error) {
 		if (copy_to_user(fildes, fd, 2*sizeof(int)))
@@ -127,6 +130,11 @@ asmlinkage int sys_ipc (uint call, int f
 {
 	int version, ret;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	version = call >> 16; /* hack for backward compatibility */
 	call &= 0xffff;
 
@@ -263,3 +271,9 @@ int kernel_execve(const char *filename, 
 	: "0" (__NR_execve),"ri" (filename),"c" (argv), "d" (envp) : "memory");
 	return __res;
 }
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
diff -ruNp linux-2.6.23.16/arch/i386/kernel/vm86.c linux-2.6.23.16-cher1/arch/i386/kernel/vm86.c
--- linux-2.6.23.16/arch/i386/kernel/vm86.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/kernel/vm86.c	2008-02-12 11:21:39.000000000 +0300
@@ -208,6 +208,11 @@ asmlinkage int sys_vm86old(struct pt_reg
 	struct task_struct *tsk;
 	int tmp, ret = -EPERM;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	tsk = current;
 	if (tsk->thread.saved_esp0)
 		goto out;
@@ -238,6 +243,11 @@ asmlinkage int sys_vm86(struct pt_regs r
 	int tmp, ret;
 	struct vm86plus_struct __user *v86;
 
+        if ((current->sbox_flags & SBOX_NO_SYSCALLS)) {
+                current->sbox_flags |= SBOX_WAS_SECURITY;
+                return -EPERM;
+        }
+
 	tsk = current;
 	switch (regs.ebx) {
 		case VM86_REQUEST_IRQ:
diff -ruNp linux-2.6.23.16/arch/i386/SYSCALLS.i386 linux-2.6.23.16-cher1/arch/i386/SYSCALLS.i386
--- linux-2.6.23.16/arch/i386/SYSCALLS.i386	1970-01-01 03:00:00.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/i386/SYSCALLS.i386	2008-02-12 11:21:39.000000000 +0300
@@ -0,0 +1,335 @@
+sys_exit								OK
+sys_fork			arch/i386/kernel/process.c *		CAP+
+sys_read                                                                OK
+sys_write                                                               OK
+sys_open			fs/open.c				CAP
+sys_close                       fs/open.c                               OK
+sys_waitpid                     kernel/exit.c                           CAP
+sys_creat                       fs/open.c                               CAP
+sys_link                        fs/namei.c                              REDIR
+sys_unlink                      fs/namei.c                              CAP+
+sys_execve                      arch/i386/kernel/process.c              CAP+
+sys_chdir			fs/open.c				CAP
+sys_time                                                                OK
+sys_mknod                       fs/namei.c                              REDIR
+sys_chmod			fs/open.c                               CAP+
+sys_lchown16                    kernel/uid16.c                          REDIR
+sys_ni_syscall                                                          ---
+sys_stat                        fs/stat.c                               CAP
+sys_lseek                       fs/read_write.c                         CAP
+sys_getpid                      kernel/timer.c                          OK
+sys_mount                       fs/namespace.c                          CAP+
+sys_oldumount                   fs/namespace.c                          REDIR
+sys_setuid16                    kernel/uid16.c                          REDIR
+sys_getuid16	                kernel/uid16.c                          OK
+sys_stime                       kernel/time.c                           CAP+
+sys_ptrace                      kernel/ptrace.c                         CAP+
+sys_alarm                       kernel/timer.c                          OK
+sys_fstat                       fs/stat.c                               CAP
+sys_pause                       kernel/signal.c                         CAP
+sys_utime                       fs/utimes.c                             CAP+
+sys_ni_syscall                                                          ---
+sys_ni_syscall                                                          ---
+sys_access			fs/open.c				CAP
+sys_nice                        kernel/sched.c                          CAP
+sys_ni_syscall                                                          ---
+sys_sync                        fs/sync.c                               CAP
+sys_kill                        kernel/signal.c                         CAP+
+sys_rename                      fs/namei.c                              REDIR
+sys_mkdir                       fs/namei.c                              REDIR
+sys_rmdir                       fs/namei.c                              CAP+
+sys_dup                         fs/fcntl.c                              CAP
+sys_pipe                        arch/i386/kernel/sys_i386.c             CAP
+sys_times                                                               OK
+sys_ni_syscall                                                          ---
+sys_brk                                                                 OK
+sys_setgid16                    kernel/uid16.c                          REDIR
+sys_getgid16                    kernel/uid16.c                          OK
+sys_signal                      kernel/signal.c                         OK
+sys_geteuid16                   kernel/uid16.c                          OK
+sys_getegid16                   kernel/uid16.c                          OK
+sys_acct                        kernel/acct.c                           CAP+
+sys_umount                      fs/namespace.c                          CAP+
+sys_ni_syscall                                                          ---
+sys_ioctl                       fs/ioctl.c                              CAP
+sys_fcntl                       fs/fcntl.c                              CAP
+sys_ni_syscall                                                          ---
+sys_setpgid                     kernel/sys.c                            CAP
+sys_ni_syscall                                                          ---
+sys_olduname                    arch/i386/kernel/sys_i386.c             OK
+sys_umask                       kernel/sys.c                            CAP
+sys_chroot			fs/open.c				CAP+
+sys_ustat                       fs/super.c                              CAP
+sys_dup2                        fs/fcntl.c                              CAP
+sys_getppid                     kernel/timer.c                          OK
+sys_getpgrp                     kernel/sys.c                            OK
+sys_setsid                      kernel/sys.c                            CAP
+sys_sigaction                   arch/i386/kernel/signal.c               OK
+sys_sgetmask                    kernel/signal.c                         OK
+sys_ssetmask                    kernel/signal.c                         CAP
+sys_setreuid16                  kernel/uid16.c                          REDIR
+sys_setregid16                  kernel/uid16.c                          REDIR
+sys_sigsuspend                  arch/i386/kernel/signal.c               CAP
+sys_sigpending                  kernel/signal.c                         CAP
+sys_sethostname                 kernel/sys.c                            CAP+
+sys_setrlimit                   kernel/sys.c                            CAP
+sys_old_getrlimit               kernel/sys.c                            OK
+sys_getrusage                   kernel/sys.c                            OK
+sys_gettimeofday                kernel/time.c                           OK
+sys_settimeofday                kernel/time.c                           CAP+
+sys_getgroups16                 kernel/uid16.c                          REDIR
+sys_setgroups16                 kernel/uid16.c                          CAP+
+old_select                      arch/i386/kernel/sys_i386.c             OK
+sys_symlink                     fs/namei.c                              REDIR
+sys_lstat                       fs/stat.c                               CAP
+sys_readlink                    fs/stat.c                               REDIR
+sys_uselib                      fs/exec.c                               CAP
+sys_swapon                      mm/swapfile.c                           CAP+
+sys_reboot                      kernel/sys.c                            CAP+
+old_readdir                     fs/readdir.c                            CAP
+old_mmap                        arch/i386/kernel/sys_i386.c             OK
+sys_munmap                                                              OK
+sys_truncate			fs/open.c				CAP
+sys_ftruncate			fs/open.c				CAP
+sys_fchmod		        fs/open.c                               CAP+
+sys_fchown16                    kernel/uid16.c                          REDIR
+sys_getpriority                 kernel/sys.c                            CAP
+sys_setpriority                 kernel/sys.c                            CAP
+sys_ni_syscall                                                          ---
+sys_statfs			fs/open.c				CAP
+sys_fstatfs			fs/open.c				CAP
+sys_ioperm                      arch/i386/kernel/ioport.c               CAP+
+sys_socketcall                  net/socket.c                            CAP+
+sys_syslog                      kernel/printk.c                         CAP
+sys_setitimer                                                           OK
+sys_getitimer                                                           OK
+sys_newstat                     fs/stat.c                               CAP
+sys_newlstat                    fs/stat.c                               CAP
+sys_newfstat                    fs/stat.c                               CAP
+sys_uname                                                               OK
+sys_iopl                        arch/i386/kernel/ioport.c               CAP+
+sys_vhangup			fs/open.c                               CAP
+sys_ni_syscall                                                          ---
+sys_vm86old                     arch/i386/kernel/vm86.c                 CAP+
+sys_wait4			kernel/exit.c                           CAP
+sys_swapoff                     mm/swapfile.c                           CAP+
+sys_sysinfo                     kernel/timer.c                          CAP
+sys_ipc                         arch/i386/kernel/sys_i386.c             CAP+
+sys_fsync                       fs/sync.c                               CAP
+sys_sigreturn                   arch/i386/kernel/signal.c               OK
+sys_clone			arch/i386/kernel/process.c *		CAP
+sys_setdomainname               kernel/sys.c                            CAP+
+sys_newuname                    kernel/sys.c                            OK
+sys_modify_ldt                  arch/i386/kernel/ldt.c                  CAP+
+sys_adjtimex                    kernel/time.c                           CAP+
+sys_mprotect                    mm/mprotect.c                           CAP
+sys_sigprocmask                 kernel/signal.c                         CAP
+sys_ni_syscall                                                          ---
+sys_init_module			kernel/module.c                         CAP+
+sys_delete_module               kernel/module.c                         CAP+
+sys_ni_syscall                                                          ---
+sys_quotactl                    fs/quota.c                              CAP+
+sys_getpgid                     kernel/sys.c                            CAP
+sys_fchdir			fs/open.c				CAP
+sys_bdflush                     fs/buffer.c                             CAP
+sys_sysfs                       fs/filesystems.c                        CAP
+sys_personality                 kernel/exec_domain.c                    CAP
+sys_ni_syscall                                                          ---
+sys_setfsuid16                  kernel/uid16.c                          REDIR
+sys_setfsgid16                  kernel/uid16.c                          REDIR
+sys_llseek                      fs/read_write.c                         CAP
+sys_getdents                    fs/readdir.c                            CAP+
+sys_select                                                              OK
+sys_flock                       fs/locks.c                              CAP+
+sys_msync                                                               OK
+sys_readv                       fs/read_write.c                         OK
+sys_writev                      fs/read_write.c                         OK
+sys_getsid                      kernel/sys.c                            CAP
+sys_fdatasync                   fs/sync.c                               CAP
+sys_sysctl                      kernel/sysctl.c                         CAP+
+sys_mlock                       mm/mlock.c                              CAP+
+sys_munlock                     mm/mlock.c                              CAP+
+sys_mlockall                    mm/mlock.c                              CAP+
+sys_munlockall                  mm/mlock.c                              CAP+
+sys_sched_setparam              kernel/sched.c                          CAP
+sys_sched_getparam              kernel/sched.c                          CAP
+sys_sched_setscheduler          kernel/sched.c                          CAP
+sys_sched_getscheduler          kernel/sched.c                          CAP
+sys_sched_yield                 kernel/sched.c                          OK
+sys_sched_get_priority_max      kernel/sched.c                          OK
+sys_sched_get_priority_min      kernel/sched.c                          OK
+sys_sched_rr_get_interval       kernel/sched.c                          OK
+sys_nanosleep                                                           OK?
+sys_mremap                      mm/mremap.c                             OK?
+sys_setresuid16                 kernel/uid16.c                          REDIR
+sys_getresuid16                 kernel/uid16.c                          OK?
+sys_vm86                        arch/i386/kernel/vm86.c                 CAP+
+sys_ni_syscall                                                          ---
+sys_poll                                                                OK
+sys_nfsservctl                  fs/nfsctl.c                             CAP+
+sys_setresgid16                 kernel/uid16.c                          REDIR
+sys_getresgid16                 kernel/uid16.c                          OK?
+sys_prctl                       kernel/sys.c                            CAP
+sys_rt_sigreturn                arch/i386/kernel/signal.c               OK
+sys_rt_sigaction                kernel/signal.c                         OK
+sys_rt_sigprocmask              kernel/signal.c                         CAP
+sys_rt_sigpending               kernel/signal.c                         CAP
+sys_rt_sigtimedwait             kernel/signal.c                         CAP
+sys_rt_sigqueueinfo             kernel/signal.c                         CAP
+sys_rt_sigsuspend               kernel/signal.c                         CAP
+sys_pread64                     fs/read_write.c                         CAP
+sys_pwrite64                    fs/read_write.c                         CAP
+sys_chown16                     kernel/uid16.c                          REDIR
+sys_getcwd                      fs/dcache.c                             CAP
+sys_capget                      kernel/capability.c                     CAP
+sys_capset                      kernel/capability.c                     CAP+
+sys_sigaltstack                 arch/i386/kernel/signal.c               OK
+sys_sendfile                    fs/read_write.c                         CAP
+sys_ni_syscall                                                          ---
+sys_ni_syscall                                                          ---
+sys_vfork			arch/i386/kernel/process.c *		CAP
+sys_getrlimit                   kernel/sys.c                            OK
+sys_mmap2                                                               OK
+sys_truncate64			fs/open.c				CAP
+sys_ftruncate64			fs/open.c				CAP
+sys_stat64                      fs/stat.c                               CAP
+sys_lstat64                     fs/stat.c                               CAP
+sys_fstat64                     fs/stat.c                               CAP
+sys_lchown                      fs/open.c                               CAP+
+sys_getuid                      kernel/timer.c                          OK
+sys_getgid                      kernel/timer.c                          OK
+sys_geteuid                     kernel/timer.c                          OK
+sys_getegid                     kernel/timer.c                          OK
+sys_setreuid                    kernel/sys.c                            CAP+
+sys_setregid                    kernel/sys.c                            CAP+
+sys_getgroups                   kernel/sys.c                            OK
+sys_setgroups                   kernel/sys.c                            CAP+
+sys_fchown                      fs/open.c                               CAP+
+sys_setresuid                   kernel/sys.c                            CAP+
+sys_getresuid                   kernel/sys.c                            OK
+sys_setresgid                   kernel/sys.c                            CAP+
+sys_getresgid                   kernel/sys.c                            OK
+sys_chown			fs/open.c				CAP+
+sys_setuid                      kernel/sys.c                            CAP+
+sys_setgid                      kernel/sys.c                            CAP+
+sys_setfsuid                    kernel/sys.c                            CAP+
+sys_setfsgid                    kernel/sys.c                            CAP+
+sys_pivot_root                  fs/namespace.c                          CAP+
+sys_mincore                     mm/mincore.c                            CAP
+sys_madvise                     mm/madvise.c                            CAP
+sys_getdents64                  fs/readdir.c                            CAP+
+sys_fcntl64                     fs/fcntl.c                              CAP
+sys_ni_syscall                                                          ---
+sys_ni_syscall                                                          ---
+sys_gettid                      kernel/timer.c                          OK
+sys_readahead                   mm/filemap.c                            CAP
+sys_setxattr                    fs/xattr.c                              CAP+
+sys_lsetxattr                   fs/xattr.c                              CAP+
+sys_fsetxattr                   fs/xattr.c                              CAP+
+sys_getxattr                    fs/xattr.c                              CAP+
+sys_lgetxattr                   fs/xattr.c                              CAP+
+sys_fgetxattr                   fs/xattr.c                              CAP+
+sys_listxattr                   fs/xattr.c                              CAP+
+sys_llistxattr                  fs/xattr.c                              CAP+
+sys_flistxattr                  fs/xattr.c                              CAP+
+sys_removexattr                 fs/xattr.c                              CAP+
+sys_lremovexattr                fs/xattr.c                              CAP+
+sys_fremovexattr                fs/xattr.c                              CAP+
+sys_tkill                       fs/signal.c                             CAP
+sys_sendfile64                  fs/read_write.c                         CAP
+sys_futex                                                               OK
+sys_sched_setaffinity           kernel/sched.c                          CAP
+sys_sched_getaffinity           kernel/sched.c                          CAP
+sys_set_thread_area                                                     OK
+sys_get_thread_area                                                     OK
+sys_io_setup                    fs/aio.c				CAP
+sys_io_destroy                  fs/aio.c                                CAP
+sys_io_getevents                fs/aio.c                                CAP
+sys_io_submit                   fs/aio.c                                CAP
+sys_io_cancel                   fs/aio.c                                CAP
+sys_fadvise64                   mm/fadvise.c                            REDIR
+sys_ni_syscall                                                          ---
+sys_exit_group			kernel/exit.c				OK?
+sys_lookup_dcookie              fs/dcookies.c                           CAP
+sys_epoll_create                fs/eventpoll.c                          CAP
+sys_epoll_ctl                   fs/eventpoll.c                          CAP
+sys_epoll_wait                  fs/eventpoll.c                          CAP
+sys_remap_file_pages            mm/fremap.c                             OK?
+sys_set_tid_address                                                     OK
+sys_timer_create	        kernel/posix-timers.c                   CAP
+sys_timer_settime               kernel/posix-timers.c                   CAP
+sys_timer_gettime               kernel/posix-timers.c                   CAP
+sys_timer_getoverrun            kernel/posix-timers.c                   CAP
+sys_timer_delete                kernel/posix-timers.c                   CAP
+sys_clock_settime               kernel/posix-timers.c                   CAP
+sys_clock_gettime               kernel/posix-timers.c                   CAP
+sys_clock_getres                kernel/posix-timers.c                   CAP
+sys_clock_nanosleep             kernel/posix-timers.c                   CAP
+sys_statfs64			fs/open.c				CAP
+sys_fstatfs64			fs/open.c				CAP
+sys_tgkill                      kernel/signal.c                         CAP
+sys_utimes                      fs/utimes.c                             REDIR
+sys_fadvise64_64                mm/fadvise.c                            OK
+sys_ni_syscall                                                          ---
+sys_mbind                       mm/mempolicy.c                          CAP
+sys_get_mempolicy               mm/mempolicy.c                          CAP
+sys_set_mempolicy               mm/mempolicy.c                          CAP
+sys_mq_open                     ipc/mqueue.c                            CAP
+sys_mq_unlink                   ipc/mqueue.c                            CAP
+sys_mq_timedsend                ipc/mqueue.c                            CAP
+sys_mq_timedreceive             ipc/mqueue.c                            CAP
+sys_mq_notify                   ipc/mqueue.c                            CAP
+sys_mq_getsetattr               ipc/mqueue.c                            CAP
+sys_kexec_load                  kernel/kexec.c                          CAP
+sys_waitid			kernel/exit.c				CAP
+sys_ni_syscall                                                          ---
+sys_add_key                     security/keys/keyctl.c                  CAP+
+sys_request_key                 security/keys/keyctl.c                  CAP+
+sys_keyctl                      security/keys/keyctl.c                  CAP+
+sys_ioprio_set                  fs/ioprio.c                             CAP+
+sys_ioprio_get                  fs/ioprio.c                             CAP+
+sys_inotify_init                fs/inotify_user.c                       CAP
+sys_inotify_add_watch           fs/inotify_user.c                       CAP
+sys_inotify_rm_watch            fs/inotify_user.c                       CAP
+sys_migrate_pages               mm/mempolicy.c                          CAP
+sys_openat                      fs/open.c                               CAP
+sys_mkdirat                     fs/namei.c                              CAP+
+sys_mknodat                     fs/namei.c                              CAP+
+sys_fchownat			fs/open.c				CAP+
+sys_futimesat                   fs/utimes.c                             CAP+
+sys_fstatat64                   fs/stat.c                               CAP
+sys_unlinkat                    fs/namei.c                              CAP+
+sys_renameat                    fs/namei.c                              CAP+
+sys_linkat                      fs/namei.c                              CAP+
+sys_symlinkat                   fs/namei.c                              CAP+
+sys_readlinkat                  fs/stat.c                               CAP
+sys_fchmodat	        	fs/open.c				CAP+
+sys_faccessat			fs/open.c				CAP
+sys_pselect6                    fs/select.c                             OK
+sys_ppoll                       fs/select.c                             OK
+sys_unshare                     kernel/fork.c                           CAP
+sys_set_robust_list             kernel/futex.c                          OK?
+sys_get_robust_list             kernel/futex.c                          OK?
+sys_splice                      fs/splice.c                             CAP
+sys_sync_file_range             fs/sync.c                               CAP
+sys_tee                         fs/splice.c                             CAP
+sys_vmsplice                    fs/splice.c                             CAP
+sys_move_pages                  mm/migrate.c                            CAP
+sys_getcpu                      kernel/sys.c                            CAP
+sys_epoll_pwait                 fs/eventpoll.c                          CAP
+sys_utimensat                   fs/utimes.c                             CAP+
+sys_signalfd                    fs/signalfd.c                           CAP
+sys_timerfd                     fs/timerfd.c                            CAP
+sys_eventfd                     fs/eventfd.c                            CAP
+sys_fallocate			fs/open.c				CAP
+
+=== END OF SYSCALL TABLE ===
+*) The line number corresponds to syscall number
+**) sys_fork, sys_vfork, sys_clone -> do_fork (kernel/fork.c)
+
+Syscall 0:
+sys_restart_syscall             kernel/signal.c                         OK
+
+syscall table in arch/i386/kernel/syscall_table.S
+
+
diff -ruNp linux-2.6.23.16/arch/x86_64/ia32/ia32_aout.c linux-2.6.23.16-cher1/arch/x86_64/ia32/ia32_aout.c
--- linux-2.6.23.16/arch/x86_64/ia32/ia32_aout.c	2008-02-11 09:06:32.000000000 +0300
+++ linux-2.6.23.16-cher1/arch/x86_64/ia32/ia32_aout.c	2008-02-12 11:21:39.000000000 +0300
@@ -285,8 +285,12 @@ static int load_aout_binary(struct linux
 	rlim = current->signal->rlim[RLIMIT_DATA].rlim_cur;
 	if (rlim >= RLIM_INFINITY)
 		rlim = ~0;
-	if (ex.a_data + ex.a_bss > rlim)
+	if (ex.a_data + ex.a_bss > rlim) {
+                if ((current->sbox_flags & SBOX_MEMLIMITON)) {
+                        current->sbox_flags |= SBOX_WAS_MEMLIMIT;
+                }
 		return -ENOMEM;
+        }
 
 	/* Flush all traces of the currently running executable */
 	retval = flush_old_exec(bprm);
@@ -526,3 +530,9 @@ static void __exit exit_aout_binfmt(void
 module_init(init_aout_binfmt);
 module_exit(exit_aout_binfmt);
 MODULE_LICENSE("GPL");
+
+/*
+ * Local variables:
+ *  c-basic-offset: 8
+ * End:
+ */
